package com.bergerkiller.bukkit.nolagg;

import java.util.Comparator;

import net.minecraft.server.ChunkCoordIntPair;

import org.bukkit.block.BlockFace;

public class ChunkCoordComparator implements Comparator<ChunkCoordIntPair> {
	private final int x, z;
	private final BlockFace direction;
	
	public ChunkCoordComparator(int x, int z, BlockFace direction) {
		this.x = x;
		this.z = z;
		this.direction = direction;
	}
	
	@Override
	public int compare(ChunkCoordIntPair a, ChunkCoordIntPair b) {
		return getIndex(a.x - this.x, a.z - this.z) - getIndex(b.x - this.x, b.z - this.z);
	}

	private int getIndex(int dx, int dz) {
		return ChunkCoordIndexer.get(dx, dz, this.direction);
	}
	
}
